Attribute VB_Name = "RUF"
'////////////// CODE FOR HANDLING RECENTLY USED FILES (RUFs) ////////////

'
'    Copyright (C) 2008  Colin Caprani - www.colincaprani.com
'
'    This program is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program.  If not, see <http://www.gnu.org/licenses/>.

'//////////////////////////// DIRECTIONS /////////////////////////////////
'1. FILL IN THE FOLLOWING CONSTANTS BELOW & THE VARIABLES IN THE /////////
'   checkForPrevious SUB FOR YOUR PARTICULAR APP /////////////////////////
'2. PLACE mnuRUF WITH AN INDEX = 1 IN YOUR APP'S MENU - SEE DEMO /////////
'3. DELETE THE THREE HIGHLIGHTED REFERENCES TO THE TEXTBOX OF THE DEMO ///
'4. USE REGEDIT TO SEE HOW THE INFO IS STORED IN THE REGISTRY ////////////
'/////////////////////////////////////////////////////////////////////////

'/////////////////////////////////////////////////////////////////////////
'///// HEALTH WARNING: MIS-USE OF REGISTRY CAN DAMAGE YOUR COMPUTER //////
'/////////////////////////////////////////////////////////////////////////

Option Explicit
'sub key for recent files
Const SECTION = "Recent Files"
'This variable references the form you are working off
Dim USER_FORM As Form
'This variable references the location where the user enters maximum
'number of RUFs. Probably in Tools-Options-File
Dim MAX_FILES_TXT As Object
'noRUF is the current number of RUFs
'MAX_FILES is the maximum allowed noumber of RUFs
'these are stored in a "Config" subkey
Dim noRUF As Integer, MAX_FILES As Integer

'///////////////// THIS SUB IS ONLY REQUIRED FOR THE DEMO ////////////////
Private Sub doText(newFile As String)
'just add the new text to the text that is there with a return at the end
USER_FORM.Text1.Text = USER_FORM.Text1.Text & newFile & vbCrLf
End Sub

Private Sub addNewFile(newFile As String)
'determine if we need to add a menu item
doLoadMenuItem
'rotate the files in the registry
doRotateFiles (newFile)
'////////////////// NEXT LINE IS REQUIRED IN DEMO ONLY ///////////////////
doText (newFile) 'add to the text box
'/////////////////////////////////////////////////////////////////////////
'fill the menu now
doMenu
End Sub

Sub doCheckfiles(newFile As String)
Dim i As Integer, j As Integer, curMenuCaption As String
Dim newMenuCaption As String

'check if newFile is already in the menu
For i = 1 To USER_FORM.mnuRUF.Count '1 to no. files in the menu
    If USER_FORM.mnuRUF(i).Tag = newFile Then     'it is in the menu
        Select Case i
            Case 1
                'do nothing if the selection is the first menu item
            Case noRUF            'selection is the last menu item
                'shift all files down the list by one by looping
                'back from the last file (noRUF)
                For j = noRUF - 1 To 1 Step -1
                    USER_FORM.mnuRUF(j + 1).Tag = USER_FORM.mnuRUF(j).Tag
                    Call doMenuCaption(j + 1, USER_FORM.mnuRUF(j + 1).Tag)
                Next j
            Case Else
                'loop backwards from the users selection
                For j = i - 1 To 1 Step -1
                    'move all items down the menu
                    USER_FORM.mnuRUF(j + 1).Tag = USER_FORM.mnuRUF(j).Tag
                    Call doMenuCaption(j + 1, USER_FORM.mnuRUF(j + 1).Tag)
                Next j
        End Select
        'make the first item the latest selection
        USER_FORM.mnuRUF(1).Tag = newFile
        Call doMenuCaption(1, newFile)
        
'////////////////// NEXT LINE IS REQUIRED IN DEMO ONLY ///////////////////
        doText (newFile) 'just update the textbox so you know it has worked
'/////////////////////////////////////////////////////////////////////////

        Exit For
    ElseIf i = USER_FORM.mnuRUF.Count Then    'it is not in the menu
       addNewFile (newFile)         'go through the other procedure
       Exit For
    End If
Next i
'check if the MAX_FILES value has changed & reduce menu items accordingly
doRationaliseMenu
End Sub

Sub doLoadMenuItem()
getMaxFiles
If noRUF < MAX_FILES Then
' change the visibility of the menu items the first time it is loaded
    Call firstMenuLoad
'haven't reached MAX_FILES yet so increase number of RUFs in menu
    noRUF = noRUF + 1
'if MAX_FILES or noRUF = 1 we would raise an error as menu item 1
'is already loaded
    If Not noRUF = 1 Then
        Load USER_FORM.mnuRUF(noRUF)
    End If
    SaveSetting App.EXEName, "Config", "noRUF", noRUF   'saves latest noRUF value
End If
End Sub

Private Sub firstMenuLoad()
'sub that changes the visibility of mnuBar1 and mnuRUF
USER_FORM.mnuBar1.Visible = True
USER_FORM.mnuRUF(1).Visible = True
End Sub

Sub checkForPrevious() 'loads the RUF list with the app start-up
Dim i As Integer, fileTxt As String

'This variable references the form you are working off
Set USER_FORM = Form1
'This constant references the location where the user enters maximum
'number of RUFs. Probably in Tools-Options-File
Set MAX_FILES_TXT = Form1.maxRufTxt

'This line checks for any previous settings
'if there are none then this is the first time the
'program has been run on this machine
fileTxt = GetSetting(App.EXEName, SECTION, "1")

If fileTxt = "" Then    'no previous settings found

'//////////////////////////////////////////////////////////////////////////
'PLACE ANY CODE THAT YOU WANT TO EXECUTE THE FIRST TIME THE APP IS RUN HERE
    MsgBox "Welcome to Colin Caprani's RUF Demo", , "RUF Demo - C. Caprani"
'//////////////////////////////////////////////////////////////////////////

    'saves the current noRUFs, zero as this is the first use
    SaveSetting App.EXEName, "Config", "noRUF", noRUF
    'set and save an initial max_files
    MAX_FILES = 3
    SaveSetting App.EXEName, "Config", "MAX_FILES", MAX_FILES
    MAX_FILES_TXT.Text = 3 'sets textbox value to current max_files
Else                    'settings exist, get them
    MAX_FILES = GetSetting(App.EXEName, "Config", "MAX_FILES", MAX_FILES)
    noRUF = GetSetting(App.EXEName, "Config", "noRUF", noRUF)
    MAX_FILES_TXT.Text = MAX_FILES

    'now get RUFs and read them into the menu so they are ready when
    'the user first sees the form
    USER_FORM.mnuBar1.Visible = True
    For i = 1 To noRUF
        fileTxt = GetSetting(App.EXEName, SECTION, i)
        'the first menu item was already loaded at design time
        If Not i = 1 Then Load USER_FORM.mnuRUF(i)
        Call doMenuCaption(i, fileTxt)
        USER_FORM.mnuRUF(i).Visible = True
    Next i
End If
End Sub

Private Sub doMenu() 'handles a change in MAX_FILES or noRUF and fills the menu
Dim i As Integer, fileTxt As String

If noRUF = MAX_FILES Then
'simply fills menu items from the data in the registry
    For i = 1 To MAX_FILES
        fileTxt = GetSetting(App.EXEName, SECTION, i)
        Call doMenuCaption(i, fileTxt)
    Next i
'the user hasn't used the program enough yet to have filled the menu up
'to MAX_FILES or else the user has recently increased MAX_FILES
ElseIf noRUF < MAX_FILES Then
    For i = 1 To noRUF
        'get filename for each RUF
        fileTxt = GetSetting(App.EXEName, SECTION, i)
        'the menu items are already loaded so just add text
        Call doMenuCaption(i, fileTxt)
    Next i
'the user could select a MAX_FILES value lower than the current noRUF value
Else
    'delete unwanted RUFs in the list
    doRationaliseMenu
    'update the menu
    doMenu
End If

End Sub

Private Sub doMenuCaption(menuIndex As Integer, sOut As String)
Dim menuLen As Long, iPos As Long, iLastPos As Long

USER_FORM.mnuRUF(menuIndex).Tag = sOut
' Easier way using API probably, but here goes:
menuLen = Len(sOut)
If (menuLen > 25) Then
    For iPos = menuLen To 1 Step -1
        If (Mid$(sOut, iPos, 1) = "\") Then
            If (menuLen - iPos) > 25 Then
                If (iLastPos = 0) Then
                    sOut = "..." & Mid$(sOut, iPos)
                    Exit For
                Else
                    sOut = "..." & Mid$(sOut, iLastPos)
                    Exit For
                End If
            Else
                iLastPos = iPos
            End If
        End If
    Next iPos
End If
USER_FORM.mnuRUF(menuIndex).Caption = "&" & menuIndex & "   " & sOut
End Sub

Private Sub doRotateFiles(newFile As String) 'moves RUFs along the registry list
Dim i As Integer

'replace the last key with the second last and so on until
'the first is now the second key and we can read our new
'filename into the "1" position unless the file the user
'has just selected is the same as last time
If Not newFile = GetSetting(App.EXEName, SECTION, "1") Then
    For i = MAX_FILES - 1 To 1 Step -1
        SaveSetting App.EXEName, SECTION, i + 1, GetSetting(App.EXEName, SECTION, i)
    Next i
    SaveSetting App.EXEName, SECTION, "1", newFile
End If
End Sub

Sub doRationaliseMenu() 'tidies up registry and menu
Dim i As Integer

getMaxFiles 'in case it has changed
If noRUF > MAX_FILES Then
    'save the new MAX_FILES value
    SaveSetting App.EXEName, "Config", "MAX_FILES", MAX_FILES
    'remove the menu item and registry key of each filename that we
    'now don't want on our menu
    For i = MAX_FILES + 1 To noRUF 'we haven't changed the value of noRUF yet
        Unload USER_FORM.mnuRUF(i)
        DeleteSetting App.EXEName, SECTION, i
    Next i
    'now read the MAX_FILES value into noRUF
    noRUF = GetSetting(App.EXEName, "Config", "MAX_FILES", MAX_FILES)
End If
End Sub

Private Sub getMaxFiles()
'get value of MAX_FILES from textbox and save it, checking for silly input
If IsNumeric(MAX_FILES_TXT) Then
    MAX_FILES = CInt(MAX_FILES_TXT)
Else:
    MsgBox "Please input a number in future, ok"
    MAX_FILES = 4
End If
If 1 > MAX_FILES Or MAX_FILES > 20 Then MAX_FILES = 4
SaveSetting App.EXEName, "Config", "MAX_FILES", MAX_FILES
'read it back in to the MAX_FILES variable
MAX_FILES = GetSetting(App.EXEName, "Config", "MAX_FILES", MAX_FILES)
'put MAX_FILES back into textbox
MAX_FILES_TXT = MAX_FILES
End Sub
